<?php
session_start();
$user_role = $_SESSION['user_role']; // Assuming user role is stored in session

include '../database.php'; // Database connection class

$db = Database::getInstance();
$students = $db->fetchAll("SELECT * FROM pg_sc_students WHERE pg_screening_status = 'pending'"); // Get all students with pending screening

include 'header.php';
?>

<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li>
                        <a href="index.php">
                            <i class="bx bx-home-alt"></i>
                        </a>
                    </li>
                    <li><span>Staff</span></li>
                    <li><span>Add Students</span></li>
                </ol>
                <a class="sidebar-right-toggle" data-open="sidebar-right"><i class="fas fa-chevron-left"></i></a>
            </div>
            <h2 class="font-weight-semibold">Add Shortlisted Applicants</h2>
        </header>

        <!-- start: page -->
        <!-- start: page -->
        <div class="row">
            <div class="col">
                <section class="card">
                    <header class="card-header">
                        <h2 class="card-title">All Shortlisted Students</h2>
                    </header>
                    <div class="card-body">
                        <a class="modal-with-form btn btn-default" href="#modalForm">Add Students</a>
                        <!-- Modal Form -->
                        <div id="modalForm" class="modal-block modal-block-primary mfp-hide">
                            <section class="card">
                                <header class="card-header">
                                    <h2 class="card-title">Add Shortlisted Students</h2>
                                </header>
                                <form method="POST" action="upload_csv.php" enctype="multipart/form-data">
                                    <div class="card-body">
                                        <div class="form-row">
                                            <div class="form-group col-md-8 offset-2">
                                                <label for="inputEmail4">Upload CSV:</label>
                                                <input type="file" id="file" name="file"
                                                    class="form-control" accept=".csv" required>
                                            </div>
                                        </div>
                                    </div>
                                    <footer class="card-footer">
                                        <div class="row">
                                            <div class="col-md-12 text-end">
                                                <button type="submit" class="btn btn-primary ">Submit</button>
                                                <button class="btn btn-default modal-dismiss">Cancel</button>
                                            </div>
                                </form>
                        </div>
                        </footer>
                </section>
            </div>
            <p>
                <?php if (isset($_GET['success'])): ?>
            <div class="alert alert-success">
                Students uploaded successfully!
            </div>
        <?php elseif (isset($_GET['error'])): ?>
            <div class="alert alert-danger">
                Error uploading students. Please try again.
            </div>
        <?php endif; ?>
        <p>
        <table class="table table-bordered table-striped mb-0" id="datatable-default">

            <thead>
                <tr>
                    <th>#</th>
                    <th>Application Number</th>
                    <th>Program</th>
                    <th>Nationality-State-LGA</th>
                    <th>Uploaded Credentials</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <?php
                if (!empty($students)) {
                    $i = 1;
                    foreach ($students as $student) {
                        // Assuming you have the necessary details like program, nationality, state, and LGA in your database
                        $state = $db->fetch("SELECT statename as name FROM tblstate WHERE stateid = ?", [$student['state']]);

                        $lga = $db->fetch("SELECT lganame as name FROM tbllga WHERE id = ?", [$student['lga']]);
                        $program = $db->fetch("SELECT name FROM tblprogramme WHERE programmeid = ?", [$student['programmeadmitted']]);

                        echo "<tr>";
                        echo "<td>" . $i++ . "</td>";
                        echo "<td>" . htmlspecialchars($student['matricnumber']) . "</td>";
                        echo "<td>" . htmlspecialchars($student['surname']) . " " . htmlspecialchars($student['firstname']) . " " . $student['othernames'] . "</td>";
                        echo "<td>" . $student['nationality'] ?? "" . "-" . $state['name'] ?? "" . "-" . $lga['name'] ?? "" . "</td>";
                        echo "<td><a href='view_credentials.php?studentid=" . $student['studentid'] . "'>View</a></td>";
                        echo "<td><a href='edit_student.php?studentid=" . $student['studentid'] . "' class='btn btn-primary btn-sm'>Edit</a></td>";
                        echo "</tr>";
                    }
                } else {
                    echo "<tr><td colspan='6'>No students found.</td></tr>";
                }
                ?>
            </tbody>

        </table>
        </div>
    </section>
</div>

<?php include 'js.php'; ?>