<?php
session_start();
$user_role = $_SESSION['user_role'];
$app_number = $_SESSION['username'];

include '../database.php'; // Database connection class

$db = Database::getInstance();


// Force the user to change password if redirected
$force_change = isset($_GET['force_change']) && $_GET['force_change'] == 1;

$user_id = $_SESSION['id']; // Assuming user_id is stored in session after login
$success_message = $error_message = "";

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the form inputs
    $current_password = $_POST['old_password'];
    $new_password = $_POST['new_password'];
    $confirm_password = $_POST['confirm_password'];

    // Fetch the user's current password from the database
    $user = $db->fetch("SELECT password FROM pg_sc_users WHERE id = ?", [$user_id]);

    if ($user) {
        // Verify the current password
        if (password_verify($current_password, $user['password'])) {
            // Check if new password and confirm password match
            if ($new_password === $confirm_password) {
                // Hash the new password
                $hashed_password = password_hash($new_password, PASSWORD_DEFAULT);

                // Update the password in the database
                $update = $db->update("UPDATE pg_sc_users SET password = ? WHERE id = ?", [$hashed_password, $user_id]);

                if ($update) {
                    $success_message = "Password changed successfully.";
                } else {
                    $error_message = "Failed to update the password. Please try again.";
                }
            } else {
                $error_message = "New password and confirm password do not match.";
            }
        } else {
            $error_message = "Current password is incorrect.";
        }
    } else {
        $error_message = "User not found.";
    }
}
include 'header.php';
?>
<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li><a href="index.php"><i class="bx bx-home-alt"></i></a></li>
                    <li><span>User</span></li>
                    <li><span>Change Password</span></li>
                </ol>
            </div>
            <h2 class="font-weight-semibold">Change User Password</h2>
        </header>

        <!-- Start: Page Content -->
        <div class="col-lg-6 offset-3">
            <?php if ($error_message): ?>
                <div class="alert alert-danger alert-dismissible fade show"><?= $error_message; ?></div>
            <?php endif; ?>

            <?php if ($force_change): ?>
                <div class="alert alert-danger alert-dismissible fade show">You must change your default password before continuing.</div>
            <?php endif; ?>

            <?php if ($success_message): ?>
                <div class="alert alert-success alert-dismissible fade show"><?= $success_message; ?></div>
            <?php endif; ?>
            <form id="form2" method="post" action="" class="form-horizontal form-bordered">
                <section class="card">
                    <header class="card-header">
                        <h2 class="card-title">Password Reset Form</h2>
                    </header>
                    <div class="card-body">
                        <div class="form-group row pb-3">
                            <label class="col-sm-4 control-label text-sm-end pt-2">Old Password:</label>
                            <div class="col-sm-8">
                                <input type="password" name="old_password" class="form-control">
                            </div>
                        </div>
                        <div class="form-group row pb-3">
                            <label class="col-sm-4 control-label text-sm-end pt-2">New Password:</label>
                            <div class="col-sm-8">
                                <input type="password" name="new_password" class="form-control">
                            </div>
                        </div>
                        <div class="form-group row pb-3">
                            <label class="col-sm-4 control-label text-sm-end pt-2">Confirm New Password:</label>
                            <div class="col-sm-8">
                                <input type="password" name="confirm_password" class="form-control">
                            </div>
                        </div>
                    </div>
                    <footer class="card-footer text-end">
                        <button class="btn btn-primary">Change</button>
                        <button type="reset" class="btn btn-default">Reset</button>
                    </footer>
                </section>
            </form>
        </div>
        <!-- End: Page Content -->
    </section>
</div>

<?php include 'js.php'; ?>