<?php
session_start();
$user_role = $_SESSION['user_role'];
$app_number = $_SESSION['username'];

include '../database.php'; // Database connection class

$db = Database::getInstance();

$success_response = $error_response = "";
// Handle form submission and update student data
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $title = $_POST['title'];
    $surname = $_POST['surname'];
    $firstname = $_POST['firstname'];
    $othernames = $_POST['othernames'];
    $gender = $_POST['gender'];
    $dob = $_POST['dob'];
    $religion = $_POST['religion'];
    $birthplace = $_POST['birthplace'];
    $nationality = $_POST['country'];
    $state = $_POST['state'];
    $lga = $_POST['lga'];
    $gsmnumber = $_POST['gsmnumber'];
    $email = $_POST['email'];
    $matricnumber = $_POST['matricnumber'];
    // Update query
    $query = "UPDATE pg_sc_students 
              SET title = :title, surname = :surname,firstname = :firstname, othernames = :othernames,dob = :dob, email = :email, gender = :gender, religion = :religion, birthplace = :birthplace, nationality = :country, state = :state, lga = :lga, gsmnumber = :gsmnumber 
              WHERE matricnumber = :matricnumber";

    // Execute the update
    $params = [
        ':title' => $title,
        ':surname' => $surname,
        ':firstname' => $firstname,
        ':othernames' => $othernames,
        ':dob' => $dob,
        ':email' => $email,
        ':gender' => $gender,
        ':religion' => $religion,
        ':birthplace' => $birthplace,
        ':country' => $nationality,
        ':state' => $state,
        ':lga' => $lga,
        ':gsmnumber' => $gsmnumber,
        ':matricnumber' => $matricnumber,
    ];

    // Update the record using the update() method from the Database class
    $rowsAffected = $db->update($query, $params);

    if ($rowsAffected >= 0) {
        $success_response = "Record updated successfully.";
    } else {
        $error_response = "Failed to update the record.";
    }
}


// Fetch student details
$student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = '" . $app_number . "'");

// Fetch countries
$countriesQuery = "SELECT * FROM tblcountries";
$countries = $db->fetchAll($countriesQuery);

// Fetch states
$statesQuery = "SELECT * FROM tblstate";
$states = $db->fetchAll($statesQuery);

// Fetch LGAs
$lgaQuery = "SELECT * FROM tbllga";
$lgas = $db->fetchAll($lgaQuery);

include 'header.php';
?>
<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li><a href="index.php"><i class="bx bx-home-alt"></i></a></li>
                    <li><span>Student</span></li>
                    <li><span>Edit Profile</span></li>
                </ol>
            </div>
            <h2 class="font-weight-semibold">Update Student Information</h2>
        </header>

        <!-- Start: Page Content -->
        <div class="row">
            <div class="col">
                <section class="card">
                    <header class="card-header">
                        <h2 class="card-title">Personal Information</h2>
                    </header>
                    <div class="card-body">
                        <?php if (isset($success_response) && !empty($success_response)) {
                            echo '
                            <div class="alert alert-success fade show" role="alert">
										' . $success_response . '
									</div>
                            ';
                            $success_response = "";
                        } else if (isset($error_response) && !empty($error_response)) {
                            echo '
                            <div class="alert alert-danger fade show" role="alert">
										' . $error_response . '
									</div>
                            ';
                            $error_response = "";
                        } ?>
                        <form class="form-horizontal form-bordered" action="" method="POST">
                            <!-- Title, Surname, Firstname, Othernames -->
                            <input type="hidden" name="matricnumber" value="<?= $student['matricnumber']; ?>">
                            <div class="form-group row pb-4">
                                <div class="col-lg-2">
                                    <label class="col-form-label" for="title">Title:</label>
                                    <input type="text" class="form-control" name="title" value="<?= $student['title'] ?>" id="title" required>
                                </div>
                                <div class="col-lg-2">
                                    <label class="col-form-label" for="surname">Surname:</label>
                                    <input type="text" class="form-control" name="surname" value="<?= $student['surname'] ?>" id="surname" required>
                                </div>
                                <div class="col-lg-4">
                                    <label class="col-form-label" for="firstname">Firstname:</label>
                                    <input type="text" class="form-control" name="firstname" value="<?= $student['firstname'] ?>" id="firstname" required>
                                </div>
                                <div class="col-lg-4">
                                    <label class="col-form-label" for="othernames">Othernames:</label>
                                    <input type="text" class="form-control" name="othernames" value="<?= $student['othernames'] ?>" id="othernames">
                                </div>
                            </div>

                            <!-- Gender, DOB, Religion, Birthplace -->
                            <div class="form-group row pb-4">
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="gender">Gender:</label>
                                    <select name="gender" id="gender" class="form-control" required>
                                        <option value="M" <?= $student['gender'] == 'M' ? 'selected' : '' ?>>Male</option>
                                        <option value="F" <?= $student['gender'] == 'F' ? 'selected' : '' ?>>Female</option>
                                    </select>
                                </div>
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="dob">Date of Birth:</label>
                                    <input type="date" class="form-control" name="dob" value="<?= $student['dob'] ?>" id="dob" required>
                                </div>
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="religion">Religion:</label>
                                    <select name="religion" id="religion" class="form-control" required>
                                        <option value="I" <?= $student['religion'] == 'I' ? 'selected' : '' ?>>Islam</option>
                                        <option value="C" <?= $student['religion'] == 'C' ? 'selected' : '' ?>>Christianity</option>
                                        <option value="O" <?= $student['religion'] == 'O' ? 'selected' : '' ?>>Others</option>
                                    </select>
                                </div>
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="birthplace">Place of Birth:</label>
                                    <input type="text" class="form-control" name="birthplace" value="<?= $student['birthplace'] ?>" id="birthplace" required>
                                </div>
                            </div>

                            <!-- Nationality, State, LGA -->
                            <div class="form-group row pb-4">
                                <div class="col-lg-4">
                                    <label class="col-form-label" for="country">Nationality:</label>
                                    <select id="country" name="country" class="form-control" required>
                                        <option value="">-- Country --</option>
                                        <?php foreach ($countries as $country): ?>
                                            <option value="<?= $country['countryid']; ?>" <?= $student['nationality'] == $country['countryid'] ? 'selected' : '' ?>><?= $country['countryname']; ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                                <div class="col-lg-4">
                                    <label class="col-form-label" for="state">State:</label>
                                    <select id="state" name="state" class="form-control" required>
                                        <option value="">-- State --</option>
                                        <?php foreach ($states as $state): ?>
                                            <option value="<?= $state['stateid']; ?>" <?= $student['state'] == $state['stateid'] ? 'selected' : '' ?>><?= $state['statename']; ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                                <div class="col-lg-4">
                                    <label class="col-form-label" for="lga">LGA:</label>
                                    <select id="lga" name="lga" class="form-control" required>
                                        <option value="">-- LGA --</option>
                                        <?php foreach ($lgas as $lga): ?>
                                            <option value="<?= $lga['lgaid']; ?>" <?= $student['lga'] == $lga['lgaid'] ? 'selected' : '' ?>><?= $lga['lganame']; ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </div>

                            <!-- GSM, Email -->
                            <div class="form-group row pb-4">
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="gsmnumber">Mobile Number:</label>
                                    <input type="text" class="form-control" name="gsmnumber" value="<?= $student['gsmnumber'] ?>" id="gsmnumber" required>
                                </div>
                                <div class="col-lg-3">
                                    <label class="col-form-label" for="email">Email:</label>
                                    <input type="email" class="form-control" name="email" value="<?= $student['email'] ?>" id="email" required>
                                </div>
                            </div>

                            <!-- Update Button -->
                            <div class="form-group row pb-4">
                                <div class="col-lg-3 offset-5">
                                    <button type="submit" class="btn btn-success">Update</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </section>
            </div>
        </div>
        <!-- End: Page Content -->
    </section>
</div>
<script src="https://code.jquery.com/jquery-3.7.1.js" integrity="sha256-eKhayi8LEQwp4NKxN+CfCh+3qOVUtJn3QNZ0TciWLP4=" crossorigin="anonymous"></script>
<script>
    $(document).ready(function() {
        // Load states when a country is selected
        $('#country').change(function() {
            var countryId = $(this).val();
            if (countryId !== "") {
                $.ajax({
                    url: 'get_data.php',
                    type: 'GET',
                    data: {
                        country_id: countryId
                    },
                    success: function(response) {
                        var states = JSON.parse(response);
                        $('#state').html('<option value="">--Select State--</option>'); // Clear previous options
                        $('#lga').html('<option value="">--Select LGA--</option>'); // Clear LGAs
                        $.each(states, function(index, state) {
                            $('#state').append('<option value="' + state.stateid + '">' + state.statename + '</option>');
                        });
                    }
                });
            } else {
                $('#state').html('<option value="">--Select State--</option>'); // Clear states if no country is selected
                $('#lga').html('<option value="">--Select LGA--</option>'); // Clear LGAs
            }
        });

        // Load LGAs when a state is selected
        $('#state').change(function() {
            var stateId = $(this).val();
            if (stateId !== "") {
                $.ajax({
                    url: 'get_data.php',
                    type: 'GET',
                    data: {
                        state_id: stateId
                    },
                    success: function(response) {
                        var lgas = JSON.parse(response);
                        $('#lga').html('<option value="">--Select LGA--</option>'); // Clear previous options
                        $.each(lgas, function(index, lga) {
                            $('#lga').append('<option value="' + lga.lgaid + '">' + lga.lganame + '</option>');
                        });
                    }
                });
            } else {
                $('#lga').html('<option value="">--Select LGA--</option>'); // Clear LGAs if no state is selected
            }
        });
    });
</script>
<?php include 'js.php'; ?>