<?php
require_once '../vendor/autoload.php'; // Include the composer autoload if you're using Composer
use Dompdf\Dompdf;
use Dompdf\Options;

session_start();

// Retrieve transaction details from the database
include '../database.php'; // Database connection
$db = Database::getInstance();

$app_number = $_SESSION['username'];

// Fetch student details
$student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = '" . $app_number . "'");
// Fetch transaction data
$transaction = $db->fetch("SELECT * FROM pg_sc_transactions WHERE student_id = '" . $student['studentid'] . "'");
$logoPath = 'http://localhost:8080/KASU/pg_screening/img/kasulogo.png';

if ($transaction) {
    // Initialize Dompdf
    $options = new Options();
    $options->set('defaultFont', 'Helvetica');
    $options->set('isRemoteEnabled', true);
    $dompdf = new Dompdf($options);

    // Prepare the HTML content for the PDF
    // Build the receipt HTML
    $html = '
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Receipt</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 20px;
            background-color: #fff;
            color: #000;
        }
        .text-center {
            text-align: center;
        }
        .text-green {
            color: green;
        }
        table {
            width: 100%;
            border-collapse: collapse;
        }
        th, td {
            padding: 8px 12px;
        }
        th {
            background-color: #f2f2f2;
        }
        .amount {
            font-size: 1.5em;
            font-weight: bold;
        }
        .total {
            color: red;
            font-size: 1.8em;
        }
    </style>
</head>
<body>
    <div class="text-center">
        <img src="' . $logoPath . '" alt="Logo" width="100">
        <h1 class="text-green">School of Postgraduate Studies</h1>
        <h2 class="text-green">Kaduna State University, Kaduna</h2>
        <h3>Acceptance Fee Payment Receipt</h3>
    </div>

    <table>
        <thead>
            <tr>
                <th>#</th>
                <th>Transaction Code</th>
                <th class="text-center">Amount</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td class="col-md-1 text-center">1</td>
                <td class="col-md-8"><em>' . $transaction['transaction_code'] . '</em></td>
                <td class="col-md-3 text-center">N' . number_format($transaction['amount'], 2) . '</td>
            </tr>
            <tr>
                <td></td>
                <td class="text-right">
                    <p><strong>Subtotal: </strong></p>
                    <p><strong>Tax: </strong></p>
                </td>
                <td class="text-center">
                    <p><strong>N' . number_format($transaction['amount'], 2) . '</strong></p>
                    <p><strong>N0.00</strong></p>
                </td>
            </tr>
            <tr>
                <td></td>
                <td class="text-right">
                    <h4><strong>Total: </strong></h4>
                </td>
                <td class="text-center total">
                    <h4><strong>N' . number_format($transaction['amount'], 2) . '</strong></h4>
                </td>
            </tr>
        </tbody>
    </table>

    <p><strong>Payment Date:</strong> ' . $transaction['payment_date'] . '</p>
    <hr>

    <p class="text-center">Thank you for your payment!</p>
</body>
</html>
';

    // Load the HTML content into Dompdf
    $dompdf->loadHtml($html);

    // Set paper size and orientation
    $dompdf->setPaper('A4', 'portrait');

    // Render the PDF
    $dompdf->render();

    // Output the generated PDF to browser for download
    $dompdf->stream('receipt_' . $transaction['transaction_code'] . '.pdf', ['Attachment' => 0]);
} else {
    echo 'No transaction found!';
}
