<?php
// Include the database connection file
include '../database.php';
$db = Database::getInstance();

// Check if the request is to fetch states based on country_id
if (isset($_GET['country_id'])) {
    $countryId = $_GET['country_id'];

    // Prepare and execute the query to fetch states based on country_id
    $statesQuery = "SELECT stateid, statename FROM tblstate WHERE countryid = ?";
    $states = $db->fetchAll($statesQuery, [$countryId]);

    // Return the results in JSON format
    echo json_encode($states);
    exit;
}

// Check if the request is to fetch LGAs based on state_id
if (isset($_GET['state_id'])) {
    $stateId = $_GET['state_id'];

    // Prepare and execute the query to fetch LGAs based on state_id
    $lgasQuery = "SELECT lgaid, lganame FROM tbllga WHERE stateid = ?";
    $lgas = $db->fetchAll($lgasQuery, [$stateId]);

    // Return the results in JSON format
    echo json_encode($lgas);
    exit;
}

// If no valid request, return an empty response
echo json_encode([]);
exit;
