<?php

$app_number = $_SESSION['username'];

$student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = '" . $app_number . "'");

// Check if the user is logged in
if (!isset($_SESSION["loggedin"]) || $_SESSION["loggedin"] !== true) {
    header("location: login.php"); // Redirect to login page if not logged in
    exit;
}

$user_id = $_SESSION["id"];
$user_role = $_SESSION["user_role"];

// Fetch the user's current password from the database
$user = $db->fetch("SELECT password FROM pg_sc_users WHERE id = ?", [$user_id]);

// Check if the user's password is still set to the default '12345'

$default_password = '12345';
if (isset($force_change) && $force_change != 1) {

    if (password_verify($default_password, $user['password'])) {
        // If the password is the default, redirect to the change password page
        header("location: change_password.php?force_change=1");
        exit;
    }
}

$paid_acc_fee = $passed_s_2 = false;
$transactions = $db->fetchAll("SELECT * FROM pg_sc_transactions WHERE student_id = '" . $student['studentid'] . "' AND status='paid'");
if (isset($transactions) && count($transactions) > 0) {
    $paid_acc_fee = true;
}
if ($student['dept_screening_status'] == "passed") {
    $passed_s_2 = true;
}
?>
<!doctype html>
<html class="left-sidebar-panel" data-style-switcher-options="{'sidebarColor': 'dark'}">

<head>

    <!-- Basic -->
    <meta charset="UTF-8">
    <title>Dashboard</title>

    <!-- Mobile Metas -->
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
    <meta name="description" content="A portal for students to upload credentials for screening at Kaduna State University.">

    <!-- Keywords -->
    <meta name="keywords" content="KASU, Kaduna State University, Student Screening, Credential Screening, PG Screening Portal">

    <!-- Author -->
    <meta name="author" content="Haruna Saidu">

    <!-- Favicon -->
    <link rel="icon" type="image/png" href="../img/kasulogo.png">

    <!-- Open Graph / Facebook -->
    <meta property="og:type" content="website">
    <meta property="og:title" content="Student Screening Portal - KASU">
    <meta property="og:description" content="A portal for students to upload their credentials for screening at Kaduna State University.">
    <meta property="og:image" content="../img/kasulogo.png">
    <meta property="og:url" content="https://portals.kasu.edu.ng/screening">
    <!-- Web Fonts  -->
    <link href="https://fonts.googleapis.com/css?family=Poppins:300,400,500,600,700,800|Shadows+Into+Light" rel="stylesheet" type="text/css">

    <!-- Vendor CSS -->
    <link rel="stylesheet" href="../vendor/bootstrap/css/bootstrap.css" />
    <link rel="stylesheet" href="../vendor/animate/animate.compat.css">
    <link rel="stylesheet" href="../vendor/font-awesome/css/all.min.css" />
    <link rel="stylesheet" href="../vendor/boxicons/css/boxicons.min.css" />
    <link rel="stylesheet" href="../vendor/magnific-popup/magnific-popup.css" />
    <link rel="stylesheet" href="../vendor/bootstrap-datepicker/css/bootstrap-datepicker3.css" />

    <!-- Specific Page Vendor CSS -->
    <link rel="stylesheet" href="../vendor/jquery-ui/jquery-ui.css" />
    <link rel="stylesheet" href="../vendor/jquery-ui/jquery-ui.theme.css" />
    <link rel="stylesheet" href="../vendor/bootstrap-multiselect/css/bootstrap-multiselect.css" />
    <link rel="stylesheet" href="../vendor/morris/morris.css" />

    <!-- Specific Page Vendor CSS -->
    <link rel="stylesheet" href="../vendor/select2/css/select2.css" />
    <link rel="stylesheet" href="../vendor/select2-bootstrap-theme/select2-bootstrap.min.css" />
    <link rel="stylesheet" href="../vendor/datatables/media/css/dataTables.bootstrap5.css" />
    <link rel="stylesheet" href="../vendor/pnotify/pnotify.custom.css" />


    <!-- Specific Page Vendor CSS -->
    <link rel="stylesheet" href="../vendor/bootstrap-tagsinput/bootstrap-tagsinput.css" />
    <link rel="stylesheet" href="../vendor/bootstrap-colorpicker/css/bootstrap-colorpicker.css" />
    <link rel="stylesheet" href="../vendor/bootstrap-timepicker/css/bootstrap-timepicker.css" />
    <link rel="stylesheet" href="../vendor/dropzone/basic.css" />
    <link rel="stylesheet" href="../vendor/dropzone/dropzone.css" />
    <link rel="stylesheet" href="../vendor/bootstrap-markdown/css/bootstrap-markdown.min.css" />
    <link rel="stylesheet" href="../vendor/summernote/summernote-bs4.css" />
    <link rel="stylesheet" href="../vendor/codemirror/lib/codemirror.css" />
    <link rel="stylesheet" href="../vendor/codemirror/theme/monokai.css" />


    <!-- Theme CSS -->
    <link rel="stylesheet" href="../css/theme.css" />

    <!-- Theme Custom CSS -->
    <link rel="stylesheet" href="../css/custom.css">

    <!-- Head Libs -->
    <script src="../vendor/modernizr/modernizr.js"></script>


</head>

<body>
    <section class="body">

        <!-- start: header -->
        <header class="header">
            <div class="logo-container">
                <a href="" class="logo">
                    <img src="../img/logo-text.png" width="260" height="40" alt="Porto Admin" />
                </a>

                <div class="d-md-none toggle-sidebar-left" data-toggle-class="sidebar-left-opened" data-target="html" data-fire-event="sidebar-left-opened">
                    <i class="fas fa-bars" aria-label="Toggle sidebar"></i>
                </div>

            </div>

            <!-- start: search & user box -->
            <div class="header-right">


                <ul class="notifications">
                    &nbsp;
                </ul>

                <span class="separator"></span>

                <div id="userbox" class="userbox">
                    <a href="#" data-bs-toggle="dropdown">
                        <figure class="profile-picture">
                            <?php
                            // Assuming the session stores user information 

                            // If the user is a student, show their name; otherwise, display the user role
                            if ($user_role == 'student') {

                                $user_name = $_SESSION['username']; // User's name if available 
                                echo '<img src="https://ui-avatars.com/api/?name="';
                                echo $user_name; // Display first letter of the user role
                                echo '"/>';
                            } else {
                                echo '<img src="https://ui-avatars.com/api/?name="';
                                echo $user_role; // Display first letter of the user role
                                echo '"/>';
                            }
                            ?>
                        </figure>
                        <div class="profile-info">
                            <span class="name">
                                <?php
                                // Show the student's name if it's available, otherwise show the role
                                if ($user_role == 'student') {
                                    echo $user_name;
                                } else {
                                    echo ucfirst($user_role); // Capitalize first letter of the role
                                }
                                ?>
                            </span>
                            <span class="role"><?php echo $user_role == 'student' ? 'Student' : ucfirst($user_role); ?></span>
                        </div>

                        <i class="fa custom-caret"></i>
                    </a>

                    <div class="dropdown-menu">
                        <ul class="list-unstyled mb-2">
                            <li class="divider"></li>
                            <li>
                                <a role="menuitem" tabindex="-1" href="../logout.php"><i class="bx bx-power-off"></i> Logout</a>
                            </li>
                        </ul>
                    </div>
                </div>

            </div>
            <!-- end: search & user box -->
        </header>
        <!-- end: header -->