<?php
session_start();
$user_role = $_SESSION['user_role'];
$app_number = $_SESSION['username'];

include '../database.php'; // Database connection class
$db = Database::getInstance();
include 'header.php';
if (!$passed_s_2) {
    echo "
    <script>
    window.location.href = './';
    </script>
    ";
}
function verifyTransaction($transaction_code)
{
    $secret_key = "sk_live_f11f9aacf1446eb02f66732be89e68ecb5925a98"; // Replace with your actual Paystack secret key
    $url = "https://api.paystack.co/transaction/verify/" . $transaction_code;

    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "GET",
        CURLOPT_HTTPHEADER => array(
            "Authorization: Bearer " . $secret_key,
            "Cache-Control: no-cache",
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        return "cURL Error #:" . $err;
    } else {
        // Decode JSON response
        $responseData = json_decode($response, true);

        if ($responseData['status'] === true && $responseData['data']['status'] === "success") {
            // echo "Transaction successful: " . $responseData['data']['gateway_response'];
            $query = "UPDATE pg_sc_transactions 
              SET  status = :status 
              WHERE transaction_code = :code";

            // Execute the update
            $params = [
                ':status' => "paid",
                ':code' => $transaction_code,
            ];
            $db = Database::getInstance();
            $db->update($query, $params);

            return true;
        } else {
            // echo "Transaction failed or incomplete: " . $responseData['data']['gateway_response'];
            return false;
        }
    }
}

// Define a function to generate a unique transaction code
function generateTransactionCode($db)
{
    $prefix = 'PGA';
    do {
        $timestamp = time(); // Current Unix timestamp
        $random_digits = rand(100, 999); // Add random digits to ensure uniqueness
        $unique_code = $prefix . $timestamp . $random_digits; // Combine prefix, timestamp, and random digits
        $exists = $db->fetch("SELECT COUNT(*) as count FROM pg_sc_transactions WHERE transaction_code = '$unique_code'");
    } while ($exists['count'] > 0); // Keep generating until a unique code is found

    return $unique_code;
}


$user_id = $_SESSION['id'];
$success_message = $error_message = "";

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
}
$transaction = $db->fetch("SELECT * FROM pg_sc_transactions WHERE student_id = '" . $student['studentid'] . "'");
$acc_fee = $db->fetch("SELECT * FROM pg_sc_acceptance_fees limit 1");
$amount = $acc_fee['acceptance_fee'];
if (empty($transaction)) {
    $payment_date = date('Y-m-d H:i:s');
    $payment_method = 'online';
    $status = 'pending'; // Default status
    // Insert data into the table
    $transaction_code = generateTransactionCode($db);
    $query = "INSERT INTO pg_sc_transactions (transaction_code, student_id, amount, payment_date, payment_method, status) 
          VALUES (?, ?, ?, ?, ?, ?)";

    $params = [$transaction_code, $student['studentid'], $amount, $payment_date, $payment_method, $status];

    // Use the insert method from the Database class
    $inserted_id = $db->insert($query, $params);

    $transaction = $db->fetch("SELECT * FROM pg_sc_transactions WHERE student_id = '" . $student['studentid'] . "'");
}
$transactionCode = $transaction['transaction_code'];
$paymentStatus = verifyTransaction($transactionCode);
?>
<style>
    .text-green {
        color: #0c6e31;
        font-family: 'Gill Sans', 'Gill Sans MT', Calibri, 'Trebuchet MS', sans-serif;
        margin: 0 0;

    }
</style>
<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li><a href="index.php"><i class="bx bx-home-alt"></i></a></li>
                    <li><span>Student</span></li>
                    <li><span>Acceptance Fee</span></li>
                </ol>
            </div>
            <h2 class="font-weight-semibold">Acceptance Fee Payment Page</h2>
        </header>

        <!-- Start: Page Content -->
        <div class="col-lg-6 offset-3">
            <?php if ($error_message): ?>
                <div class="alert alert-danger alert-dismissible fade show"><?= $error_message; ?></div>
            <?php endif; ?>

            <?php if ($success_message): ?>
                <div class="alert alert-success alert-dismissible fade show"><?= $success_message; ?></div>
            <?php endif; ?>
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="text-center">
                            <img src="../img/kasulogo.png" alt="">
                            <h1 class="text-green">School of Postgraduate Studies</h1>
                            <h2 class="text-green">Kaduna State University, Kaduna</h2>
                        </div>
                        <div class="row">
                            <div class="text-center">

                                <h1>Acceptance Fee</h1>
                            </div>
                            </span>
                            <table class="table table-hover">
                                <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>Transaction Code</th>
                                        <th class="text-center">Amount</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr>
                                        <td class="col-md-1" style="text-align: center"> 1 </td>
                                        <td class="col-md-8"><em><?= $transaction['transaction_code']; ?></em></h4>
                                        </td>

                                        <td class="col-md-3 text-center">&#8358;<?= number_format($transaction['amount'], 2); ?></td>
                                    </tr>
                                    <tr>
                                        <td>   </td>
                                        <td class="pull-right">
                                            <p>
                                                <strong>Subtotal: </strong>
                                            </p>
                                            <p>
                                                <strong>Tax: </strong>
                                            </p>
                                        </td>
                                        <td class="text-center">
                                            <p>
                                                <strong>&#8358; 10,000.00</strong>
                                            </p>
                                            <p>
                                                <strong>&#8358; 0.00</strong>
                                            </p>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>   </td>
                                        <td class="pull-right">
                                            <h4><strong>Total: </strong></h4>
                                        </td>
                                        <td class="text-center text-danger">
                                            <h4><strong>&#8358;10,000.00</strong></h4>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                            <?php if ($paymentStatus): ?>
                                <a class="btn btn-success btn-lg btn-block" href="generate_receipt.php" target="_blank">Print Receipt
                                    <span class="fas fa-print"></span>
                                </a>
                            <?php else: ?>
                                <button type="button" class="btn btn-success btn-lg btn-block" id="pay">
                                    Pay Acceptance Now   <span class="glyphicon glyphicon-chevron-right"></span>
                                </button>
                            <?php endif ?>
                            </td>
                        </div>
                    </div>
                </div>
            </div>
            <!-- End: Page Content -->
    </section>
</div>

<script src="https://js.paystack.co/v2/inline.js"></script>
<script>
    document.querySelector('#pay').addEventListener('click', function() {
        const handler = PaystackPop.setup({
            key: 'pk_live_04b1b358df05eb530e8580a4b3b62595eade936c', // Replace with your Paystack public key
            email: '<?= $student["email"] ?>', // Student's email
            amount: <?= ($amount * 100); ?>, // Amount in kobo (10,000 NGN)
            currency: "NGN",
            ref: '<?= $transaction["transaction_code"] ?>', // Unique transaction reference
            callback: function(response) {
                alert('Success. Transaction ref is ' + response.reference + '. refresh the page to update the payment');
                // window.location.href = 'receipt.php?reference=' + response.reference;
            },
            onClose: function() {
                alert('Transaction was not completed.');
            }
        });
        handler.openIframe();
    });
</script>
<?php include 'js.php'; ?>