<?php
session_start();
$user_role = $_SESSION['user_role'];
$app_number = $_SESSION['username'];

include '../database.php'; // Database connection class

$db = Database::getInstance();
$success_message = $error_message = '';

include 'header.php';
$changedPassword = $updatedProfile = $uploadedCreds = $passed_s_1 = $passed_s_2 = $paid_acc_fee = $proceed_to_portal = false;

if (!password_verify("12345", $user['password'])) {
    $changedPassword = true;
}

$student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = '" . $app_number . "'");

$creds = $db->fetchAll("SELECT * FROM pg_sc_credentials_uploads WHERE student_id = '" . $student['studentid'] . "'");
$transactions = $db->fetchAll("SELECT * FROM pg_sc_transactions WHERE student_id = '" . $student['studentid'] . "' AND status='paid'");
if (isset($transactions) && count($transactions) > 0) {
    $paid_acc_fee = true;
}
if (!empty($student['title'])) {
    $updatedProfile = true;
}
if ($student['proceed_to_portal'] == 1) {
    $proceed_to_portal = true;
}

if (isset($creds) && count($creds) > 0) {
    $uploadedCreds = true;
}



if ($student['pg_screening_status'] == "passed") {
    $passed_s_1 = true;
}
if ($student['dept_screening_status'] == "passed") {
    $passed_s_2 = true;
}

?>
<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li><a href="index.php"><i class="bx bx-home-alt"></i></a></li>
                    <li><span>Student</span></li>
                    <li><span>Screening Status</span></li>
                </ol>
            </div>
            <h2 class="font-weight-semibold">View your screening</h2>
        </header>

        <!-- Start: Page Content -->
        <div class="timeline">
            <div class="tm-body">
                <div class="tm-title">
                    <h5 class="m-0 pt-2 pb-2 text-dark font-weight-semibold text-uppercase">Screening Process</h5>
                </div>
                <ol class="tm-items">
                    <li>
                        <div class="tm-<?= $changedPassword ? "success" : "info" ?>">
                            <div class="tm-icon">
                                <?php
                                if ($changedPassword) {
                                    echo '<i class="fas fa-check "></i>';
                                } else {
                                    echo '<i class="fas fa-lock"></i>';
                                }
                                ?>
                            </div>
                            <time class="tm-datetime" datetime="2021-11-22 19:13">
                                <div class="tm-datetime-date">Password Changed</div>
                            </time>
                        </div>
                        <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="100" style="animation-delay: 100ms;">
                            <p>
                                You should change your password.
                            </p>
                        </div>
                    </li>
                    <li>
                        <div class="tm-<?= $updatedProfile ? "success" : "info" ?>">
                            <div class="tm-icon">
                                <?php
                                if ($updatedProfile) {
                                    echo '<i class="fas fa-check "></i>';
                                } else {
                                    echo '<i class="fas fa-lock"></i>';
                                }
                                ?>
                            </div>
                            <time class="tm-datetime" datetime="2021-11-19 18:13">
                                <div class="tm-datetime-date">Update Profile</div>
                            </time>
                        </div>
                        <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="250" style="animation-delay: 250ms;">
                            <p>
                                Update user profile with correct and current information
                            </p>
                        </div>
                    </li>
                    <li>
                        <div class="tm-<?= $uploadedCreds ? "success" : "info" ?>">
                            <div class="tm-icon">
                                <?php
                                if ($uploadedCreds) {
                                    echo '<i class="fas fa-check "></i>';
                                } else {
                                    echo '<i class="fas fa-lock"></i>';
                                }
                                ?>
                            </div>
                            <time class="tm-datetime" datetime="2021-11-14 17:25">
                                <div class="tm-datetime-date">Upload Credentials</div>
                            </time>
                        </div>
                        <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="400" style="animation-delay: 400ms;">
                            <p>
                                Upload all your credentials. That is what the screening officers will use to screen you.
                            </p>
                        </div>
                    </li>
                    <li>
                        <div class="tm-info">
                            <div class="tm-<?= $passed_s_1 ? "success" : "info" ?>">
                                <div class="tm-icon">
                                    <?php
                                    if ($passed_s_1) {
                                        echo '<i class="fas fa-check "></i>';
                                    } else {
                                        echo '<i class="fas fa-lock"></i>';
                                    }
                                    ?>
                                </div>
                                <time class="tm-datetime" datetime="2021-11-14 17:25">
                                    <div class="tm-datetime-date">First Screening</div>
                                </time>
                            </div>
                            <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="400" style="animation-delay: 400ms;">
                                <p>
                                    First screening will be by the PG School screening officer.
                                </p>
                            </div>
                    </li>
                    <li>
                        <div class="tm-info">
                            <div class="tm-<?= $passed_s_2 ? "success" : "info" ?>">
                                <div class="tm-icon">
                                    <?php
                                    if ($passed_s_2) {
                                        echo '<i class="fas fa-check "></i>';
                                    } else {
                                        echo '<i class="fas fa-lock"></i>';
                                    }
                                    ?>
                                </div>
                                <time class="tm-datetime" datetime="2021-11-14 17:25">
                                    <div class="tm-datetime-date">Second Screening</div>
                                </time>
                            </div>
                            <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="400" style="animation-delay: 400ms;">
                                <p>
                                    Second screening will be by the departmental screening officer.
                                </p>
                            </div>
                    </li>
                    <li>
                        <div class="tm-<?= $paid_acc_fee ? "success" : "info" ?>">
                            <div class="tm-icon">
                                <?php
                                if ($paid_acc_fee) {
                                    echo '<i class="fas fa-check "></i>';
                                } else {
                                    echo '<i class="fas fa-lock"></i>';
                                }
                                ?>
                            </div>
                            <time class="tm-datetime" datetime="2021-11-14 17:25">
                                <div class="tm-datetime-date">Pay Acceptance Fee</div>
                            </time>
                        </div>
                        <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="400" style="animation-delay: 400ms;">
                            <p>
                                Students that has passed both screening will pay acceptance fee.
                            </p>
                        </div>
                    </li>
                    <li>
                        <div class="tm-<?= $proceed_to_portal ? "success" : "info" ?>">
                            <div class="tm-icon">
                                <?php
                                if ($proceed_to_portal) {
                                    echo '<i class="fas fa-check "></i>';
                                } else {
                                    echo '<i class="fas fa-lock"></i>';
                                }
                                ?>
                            </div>
                            <time class="tm-datetime" datetime="2021-11-14 17:25">
                                <div class="tm-datetime-date">Student Portal</div>
                            </time>
                        </div>
                        <div class="tm-box appear-animation animated fadeInRight appear-animation-visible" data-appear-animation="fadeInRight" data-appear-animation-delay="400" style="animation-delay: 400ms;">
                            <p>
                                Students will proceed to the student portal where he can download his admission letter and pay his school.
                            </p>
                        </div>
                    </li>
                </ol>
            </div>
        </div>
        <!-- End: Page Content -->
    </section>
</div>

<?php include 'js.php'; ?>