<?php
session_start();
$user_role = $_SESSION['user_role'];
$app_number = $_SESSION['username'];

include '../database.php'; // Database connection class

$db = Database::getInstance();

$success_response = $error_response = "";
// Handle form submission and update student data
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['file'])) {
    // Define upload directory
    $targetDir = "../img/credentials/";
    $name = $_POST['name'];

    // Retrieve the file details
    $fileName = basename($_FILES["file"]["name"]);
    $targetFilePath = $targetDir . $fileName;
    $fileType = strtolower(pathinfo(
        $targetFilePath,
        PATHINFO_EXTENSION
    ));

    // Validate file type (only allow jpg and png)
    $allowedTypes = array('jpg', 'png');
    if (in_array($fileType, $allowedTypes)) {
        // Attempt to move the file to the target directory
        if (move_uploaded_file($_FILES["file"]["tmp_name"], $targetFilePath)) {
            // Fetch student details (assuming $app_number contains matricnumber)
            $student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = ?", [$app_number]);

            if ($student) {
                // Insert the file details into the database
                $documentName = $_POST['name'];
                $filePath = $targetFilePath;
                $studentId = $student['studentid'];

                $query = "INSERT INTO pg_sc_credentials_uploads (student_id, document_name, file_path) VALUES (?, ?, ?)";
                $params = [$studentId, $documentName, $filePath];

                $insertId = $db->insert($query, $params);

                if ($insertId > 0) {
                    $success_response = "File uploaded and record saved successfully.";
                } else {
                    $error_response = "Failed to save the record to the database.";
                }
            } else {
                $error_response = "Student not found.";
            }
        } else {
            $error_response = "Failed to upload the file.";
        }
    } else {
        $error_response = "Invalid file type. Only JPG and PNG files are allowed.";
    }
}


// Handle delete request
if (isset($_GET['delete_id'])) {
    $delete_id = $_GET['delete_id'];
    // Fetch the file details
    $cred = $db->fetch("SELECT * FROM pg_sc_credentials_uploads WHERE upload_id = ?", [$delete_id]);

    if ($cred) {
        // Delete the file from the folder
        if (file_exists($cred['file_path'])) {
            unlink($cred['file_path']); // Delete file
        }

        // Delete the record from the database
        $db->execute("DELETE FROM pg_sc_credentials_uploads WHERE upload_id = ?", [$delete_id]);

        $success_response = "File and record deleted successfully.";
    } else {
        $error_response = "Record not found.";
    }
}


// Fetch student details
$student = $db->fetch("SELECT * FROM pg_sc_students WHERE matricnumber = '" . $app_number . "'");

$creds = $db->fetchAll("SELECT * FROM pg_sc_credentials_uploads WHERE student_id = '" . $student['studentid'] . "'");

include 'header.php';
?>
<div class="inner-wrapper">
    <?php include 'aside.php'; ?>

    <section role="main" class="content-body">
        <header class="page-header page-header-left-breadcrumb">
            <div class="right-wrapper">
                <ol class="breadcrumbs">
                    <li><a href="index.php"><i class="bx bx-home-alt"></i></a></li>
                    <li><span>Student</span></li>
                    <li><span>Edit Profile</span></li>
                </ol>
            </div>
            <h2 class="font-weight-semibold">Update Student Information</h2>
        </header>

        <!-- Start: Page Content -->
        <div class="row">
            <div class="col">
                <section class="card">
                    <header class="card-header">
                        <h2 class="card-title">Uploaded Credentials</h2>
                    </header>
                    <div class="card-body">
                        <span class="pull-right">
                            <a class="modal-with-form btn btn-default" href="#modalForm">Upload New Credential</a>
                            <!-- Modal Form -->
                            <div id="modalForm" class="modal-block modal-block-primary mfp-hide">
                                <section class="card">
                                    <header class="card-header">
                                        <h2 class="card-title">Add Shortlisted Students</h2>
                                    </header>
                                    <form method="POST" action="" enctype="multipart/form-data">
                                        <div class="card-body">
                                            <div class="form-row">
                                                <div class="form-group col-md-8 offset-2">
                                                    <label for="inputEmail4">File Name:</label>
                                                    <input type="text" id="name" name="name"
                                                        class="form-control" required>
                                                </div>
                                                <div class="form-group col-md-8 offset-2">
                                                    <label for="inputEmail4">Upload Credential:</label>
                                                    <input type="file" id="file" name="file"
                                                        class="form-control" accept=".jpg, .png" required>
                                                </div>
                                            </div>
                                        </div>
                                        <footer class="card-footer">
                                            <div class="row">
                                                <div class="col-md-12 text-end">
                                                    <button type="submit" class="btn btn-primary ">Submit</button>
                                                    <button class="btn btn-default modal-dismiss">Cancel</button>
                                                </div>
                                            </div>
                                        </footer>
                                    </form>
                            </div>
                        </span>
                        <p>&nbsp;</p>
                        <div class="row">
                            <?php if (isset($creds) && !empty($creds) > 0) {
                                foreach ($creds as $cred) {

                            ?>
                                    <div class="col-md-4">
                                        <h5 class="font-weight-semibold text-dark text-uppercase"><?= $cred['document_name']; ?></h5>
                                        <a href="<?= $cred['file_path']; ?>" data-plugin-lightbox="" data-plugin-options="{ &quot;type&quot;:&quot;image&quot; }" title="Caption. Can be aligned it to any side and contain any HTML.">
                                            <img class="img-fluid" src="<?= $cred['file_path']; ?>" width="145">
                                        </a>
                                        <h5>
                                            <a href="?delete_id=<?= $cred['upload_id']; ?>" class="btn btn-danger btn-sm" onclick="return confirm('Are you sure you want to delete this file?');">Delete</a>
                                        </h5>
                                    </div>
                                <?php
                                }
                            } else {
                                ?>
                                <center>
                                    No credentials uploaded yet
                                </center>
                            <?php
                            }
                            ?>
                        </div>
                    </div>
                </section>
            </div>
        </div>
        <!-- End: Page Content -->
    </section>
</div>
<?php include 'js.php'; ?>